﻿/*  Copyright © exc-jdbi 2021

    © Finite Field  2012

    © Finite Field  2012 is Free and Opensource Software
    
    www.vb-paradise.de/index.php/User/23082-exc-jdbi/
 
    github.com/exc-jdbi
*/

using System;
using System.Linq;
using System.Collections.Generic;

namespace FiniteFields
{
  public partial class FiniteField
  {

    /// <summary>
    /// Addiert zwei Polynome
    /// </summary>
    /// <param name="summand1">Polynom als Summand</param>
    /// <param name="summand2">Polynom als Summand</param>
    /// <param name="irreducible_polynomial">Das Irreduzible Polynom</param>
    /// <param name="modulo">Begrenzt den Grad (Degree) des Polynom auf den Modulowert.</param>
    /// <returns>
    /// Gibt das Resultat und den Rest zurück.
    /// </returns>
    private static (int[], int[]) FFPolynomAddition(
      int[] summand1, int[] summand2, 
      int[] irreducible_polynomial, int modulo)
    {
      var ffsum = FFPolynomAdditionInternal(summand1, summand2, modulo);
      if (ffsum.Length < irreducible_polynomial.Length) return (new[] { 0 }, ffsum);
      return FFPolynomDivision(ffsum, irreducible_polynomial, modulo);
    }

    private static int[] FFPolynomAdditionInternal(
      int[] summand1, int[] summand2, int modulo)
    {
      var a = summand1.Reverse().ToArray();
      var t = summand2.Reverse().ToArray();
      if (summand1.Length < summand2.Length)
        Swap(ref a, ref t);

      var b = new int[a.Length];
      Array.Copy(t, b, t.Length);
      var result = new List<int>(a);
      for (int i = 0; i < b.Length; i++)
        result[i] = (result[i] + b[i]) % modulo;

      result.Reverse();
      return result.ToArray();
    }


  }
}
