﻿/*  Copyright © exc-jdbi 2021

    © Finite Field  2012

    © Finite Field  2012 is Free and Opensource Software
    
    www.vb-paradise.de/index.php/User/23082-exc-jdbi/
 
    github.com/exc-jdbi
*/

using System.Linq;

namespace FiniteFields
{
  public partial class FiniteField
  {
    private static (int[], int[]) FFPolynomMultiplication(
      int[] multiplier, int[] multiplicand, int[] irreducible_polynomial, int modulo)
    {
      var ffproduct = FFPolynomMultiplicationInternal(multiplier, multiplicand, modulo);
      if (ffproduct.Length < irreducible_polynomial.Length)
        //Result = 0; Remainder ffproduct
        return (new[] { 0 }, ffproduct);
      
      return FFPolynomDivision(ffproduct, irreducible_polynomial, modulo);
    }

    private static int[] FFPolynomMultiplicationInternal(
      int[] multiplier, int[] multiplicand, int modulo)
    {
      //modulo is generator
      var a = multiplier.Reverse().ToArray();
      var b = multiplicand.Reverse().ToArray();
      int[] result = new int[a.Length + b.Length - 1];

      for (int i = 0; i < a.Length; i++)
        for (int j = 0; j < b.Length; j++)
          result[i + j] += a[i] * b[j];

      ExtMod(result, modulo);
      return result.Reverse().ToArray();
    }

  }
}
