﻿/*  Copyright © exc-jdbi 2021

    © Finite Field  2012

    © Finite Field  2012 is Free and Opensource Software
    
    www.vb-paradise.de/index.php/User/23082-exc-jdbi/
 
    github.com/exc-jdbi
*/

using System;
using System.Linq;
using System.Collections.Generic;

namespace FiniteFields
{
  public partial class FiniteField
  {
    /// <summary>
    /// Gibt eine Kopie zurück.
    /// </summary>
    /// <returns></returns>
    public FiniteField Copy()
    => new FiniteField(this);

    //Swap zwei arrays
    private static void Swap(ref int[] a, ref int[] b)
    {
      int[] t = a; a = b; b = t;
    }

    //Swap zwei numerische Werte
    private static void Swap(ref int a, ref int b)
    {
      int t = a; a = b; b = t;
    }

    private static bool GreaterEqual(int[] polynom1, int[] polynom2)
    {
      //Nullbereinigt
      if (polynom1.Length > polynom2.Length) return true;
      if (polynom1.Length < polynom2.Length) return false;
      if (polynom1.SequenceEqual(polynom2)) return true;
      // d.h. beide Arrays sind gleich lang
      for (int i = 0; i < polynom1.Length; i++)
      {
        if (polynom1[i] < polynom2[i]) return false;
        if (polynom1[i] > polynom2[i]) return true;
      }
      throw new Exception("Operator >= is false");
    }

    private static bool LessEqual(int[] polynom1, int[] polynom2)
    {
      //Nullbereinigt
      if (polynom1.Length < polynom2.Length) return true;
      if (polynom1.Length > polynom2.Length) return false;
      if (polynom1.SequenceEqual(polynom2)) return true;
      // d.h. beide Arrays sind gleich lang
      for (int i = 0; i < polynom1.Length; i++)
      {
        if (polynom1[i] > polynom2[i]) return false;
        if (polynom1[i] < polynom2[i]) return true;
      }
      throw new Exception("Operator <= is false");
    }
    private static bool LessThen(int[] polynom1, int[] polynom2)
    {
      //Nullbereinigt
      if (polynom1.Length < polynom2.Length) return true;
      if (polynom1.Length > polynom2.Length) return false;
      if (polynom1.SequenceEqual(polynom2)) return false;
      // d.h. beide Arrays sind gleich lang
      for (int i = 0; i < polynom1.Length; i++)
      {
        if (polynom1[i] > polynom2[i]) return false;
        if (polynom1[i] < polynom2[i]) return true;
      }
      throw new Exception("Operator < is false");
    }

    private static bool GreaterThen(int[] b1, int[] b2)
    {
      if (b1.Length > b2.Length) return true;
      if (b1.Length < b2.Length) return false;
      if (b1.SequenceEqual(b2)) return false;
      // d.h. beide Arrays sind gleich lang
      for (int i = 0, loopTo = b1.Length - 1; i <= loopTo; i++)
      {
        if (b1[i] < b2[i]) return false;
        if (b1[i] > b2[i]) return true;
      }
      throw new Exception("Operator > is false");
    }

    private static int CleanseZeros(ref List<int> polynom)
    {
      var newarr = polynom.ToArray();
      int result = CleanseZeros(ref newarr);
      polynom = newarr.ToList();
      return result;
    }

    private static int CleanseZeros(ref int[] polynom)
    {
      var zero = new int[] { 0 };
      if (polynom is null)
      {
        polynom = zero;
        return 0;
      }

      if (polynom.Length == 0)
      {
        polynom = zero;
        return 0;
      }

      int counts = 0;
      for (int i = 0, loopTo = polynom.Length - 1; i <= loopTo; i++)
        if (polynom[i] == 0)
          counts += 1;
        else break;

      if (counts == 0)
        return 0;

      if (polynom.Length == counts)
      {
        polynom = zero;
        return counts;
      }

      polynom = polynom.Skip(counts).ToArray();
      return counts;
    }
  }
}
