﻿/*  Copyright © exc-jdbi 2017

    © nsc 2017

    © nsc is Free and Opensource Software
    
    www.vb-paradise.de/index.php/User/23082-exc-jdbi/
 
    github.com/exc-jdbi
*/

using System;
using System.Linq;
using System.ComponentModel;
using System.Collections.Generic;

//Important: There are no exception treatments

namespace NumeralSystemConverter
{
  /// <summary>
  /// © NCS 2017 - Numeral System Converter
  /// <para></para>
  /// Created by © exc-jdbi 2017
  /// <para></para>
  /// https://www.vb-paradise.de/index.php/Thread/121201-NSC-Zahlensysteme-umrechnen-von-einer-Basis-in-ein-Anderes/
  /// </summary>
  /// <summary>
  /// Numeral System Converter
  /// </summary>
  [Browsable(false)]
  [EditorBrowsable(EditorBrowsableState.Never)]
  //[DebuggerBrowsable(DebuggerBrowsableState.Never)]
  //[DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
  internal partial class NSC
  {
    /// <summary>
    /// Converts an Integer-Array with 'Natural Numbers' 
    /// from one base to another.
    /// <para></para>
    /// Important: There are no exception treatments. 
    /// <para></para>
    /// Created by @ exc-jdbi 2017.
    /// </summary>
    /// <param name="input">Initial values</param>
    /// <param name="startBase">Starting base</param>
    /// <param name="targetBase">Target base</param>
    /// <returns>Returns a list with the new values</returns>
    /// <history>Created by © exc-jdbi 2017</history>
    public static int[] Converts(int[] input, int startbase, int targetbase)
    {
      if (input is null || input.Length < 1)
        throw new InvalidOperationException();
      startbase = startbase < 2 ? Math.Abs(startbase) : startbase;
      targetbase = targetbase < 2 ? Math.Abs(targetbase) : targetbase;

      bool ext = true;
      int remainder = 0, tmp = 0;
      int[] ipt = input.ToArray();
      int cap = Convert.ToInt32(ipt.Length * 
          Math.Log(startbase) / Math.Log(targetbase)) + 1;

      Stack<int> result = new Stack<int>(cap);
      while (ext)
      {
        remainder = 0; ext = false;
        for (int i = 0; i <= ipt.Length - 1; i++)
        {
          tmp = ((startbase * remainder) + ipt[i]) % targetbase;
          ipt[i] = ((startbase * remainder) + ipt[i]) / targetbase;
          remainder = tmp;
          if (ipt[i] > 0)
            ext = true;
        }
        result.Push(remainder);
      }
      return result.ToArray();
    }
    private NSC() { }
  }
}
