﻿/*  Copyright © exc-jdbi 2017

    © nsc 2017

    © nsc is Free and Opensource Software
    
    www.vb-paradise.de/index.php/User/23082-exc-jdbi/
 
    github.com/exc-jdbi
*/

using System;
using System.Collections.Generic;

//Important: There are no exception treatments

namespace NumeralSystemConverter
{
  internal partial class NSC
  {
    /// <summary>
    /// Eine Nummer zu einer Int32 Array
    /// </summary>
    /// <param name="number">Nummer</param>
    /// <returns>Int32 Array</returns>
    public static int[] ToNumbers(int number)
    {
      var result = new List<int>(30);
      while (number > 0)
      {
        result.Add(number % 10);
        number /= 10;
      }
      result.Reverse();
      return result.ToArray();
    }

    /// <summary>
    /// Int32 Array wieder zu einer Nummer.
    /// </summary>
    /// <param name="data">Die Zahl als Int32 Array</param>
    /// <returns>Gibt eine Int32 Zahl zurück</returns>
    public static int NumbersToI32(int[] data)
    {
      return Convert.ToInt32(NumbersToStr(data));
    }

    /// <summary>
    /// Konvertiert eine Stringzahl zu einem nummerischen Wert.
    /// </summary>
    /// <param name="data"></param>
    /// <returns>Int32 Nummer</returns>
    public static int NumbersToI32(string data)
    {
      return Convert.ToInt32(data);
    }

    /// <summary>
    /// Int32 Array zu einer String-Nummer.
    /// </summary>
    /// <param name="data">Die Zahl als Int32 Array</param>
    /// <param name="_concatdirect">Option: False mit Trennzeichen</param>
    /// <returns>String Nummer</returns>
    public static string NumbersToStr(int[] data, bool _concatdirect = true)
    {
      if (_concatdirect) return string.Join("", data);
      return string.Join("-", data);
    }
  }
}
