﻿'    Copyright © exc-jdbi 2021

'    © Finite Field  2012

'    © Finite Field  2012 Is Free And Opensource Software

'    https://www.vb-paradise.de/index.php/User/23082-exc-jdbi/

'    github.com/ exc - jdbi

Option Strict On
Option Explicit On
Imports FiniteFields

Public Module TestFiniteFields
  Public ReadOnly Rand As Random = New Random
  Public Sub Main()
    Console.WriteLine("Author: Created by exc-jdbi 2021")
    Console.WriteLine()


    TestFiniteField()
    TestTable()

    Console.ReadLine()
  End Sub

  Private Sub TestFiniteField()
    'Polynomial = x ^ 6 + x ^ 4 + 4 * x ^ 3 + x ^ 2 + 2 = 15625 + 625 + 500 + 25 + 2 = 16777
    Dim polynomial = FiniteField.FromPolynom(New Int32() {1, 0, 1, 4, 1, 0, 2}, 5)
    Dim gfx_1, gfx_2, gfx_3, gfx_4 As FiniteField

    For i = 0 To 1000
      gfx_1 = New FiniteField(5, 6, polynomial, Rand.Next(1, polynomial))
      gfx_2 = New FiniteField(5, 6, polynomial, Rand.Next(1, polynomial))

      'Addition
      gfx_3 = gfx_1 + gfx_2
      gfx_4 = gfx_3 - gfx_2
      Debug.Assert(gfx_1 = gfx_4)

      'Subtraktion
      gfx_3 = gfx_1 - gfx_2
      gfx_4 = gfx_3 + gfx_2
      Debug.Assert(gfx_1 = gfx_4)

      If gfx_2 = 0 Then Continue For

      'Multiplikation
      gfx_3 = gfx_1 * gfx_2
      gfx_4 = gfx_3 / gfx_2
      Debug.Assert(gfx_1 = gfx_4)

      'Division
      gfx_3 = gfx_1 / gfx_2
      gfx_4 = gfx_3 * gfx_2
      Debug.Assert(gfx_1 = gfx_4)
    Next
  End Sub

  Private Sub TestTable()
    Dim gfx_1 As FiniteField

    'Ein paar Möglichkeiten
    'gfx_1 = New FiniteField(3, 3, 46, 0)
    'gfx_1 = New FiniteField(3, 2, 10, 0)
    'gfx_1 = New FiniteField(2, 3, 11, 0)
    gfx_1 = New FiniteField(2, 4, 19, 0)

    'Numeric multiplication table
    Dim tableaddnum = gfx_1.ToFFAdditionTable()

    'Polynomial multiplication table
    Dim tableaddpolynom = gfx_1.ToFFAdditionPolynomTable()

    'Numeric multiplication table
    Dim tablemultnum = gfx_1.ToFFMultiplicationTable()

    'Polynomial multiplication table
    Dim tablemultpolynom = gfx_1.ToFFMultiplicationPolynomTable()

    PrintTable(tableaddnum)
    PrintTable(tableaddpolynom)
    PrintTable(tablemultnum)
    PrintTable(tablemultpolynom)


  End Sub

  Private Sub PrintTable(table()() As Int32, Optional _padrightsize As Int32 = 3)
    For i = 0 To table.Length - 1
      For j = 0 To table.Length - 1
        Console.Write($"{table(i)(j).ToString.PadRight(_padrightsize)}")
      Next
      Console.WriteLine()
    Next
    Console.WriteLine()
  End Sub

  Private Sub PrintTable(table()()() As Int32)
    For i = 0 To table.Length - 1
      For j = 0 To table.Length - 1
        Console.Write($"[{String.Join(",", table(i)(j))}] ")
      Next
      Console.WriteLine()
    Next
    Console.WriteLine()
  End Sub
End Module
